=== modified file 'sql/item_cmpfunc.h'
--- sql/item_cmpfunc.h	2014-11-01 21:08:09 +0000
+++ sql/item_cmpfunc.h	2014-11-03 07:23:59 +0000
@@ -28,6 +28,25 @@
 #define PCRE_STATIC 1             /* Important on Windows */
 #include "pcre.h"                 /* pcre header file */
 
+
+class Hybrid_cmp_context
+{
+  Item_result m_compare_type;
+protected:
+  DTCollation cmp_collation;
+public:
+  Hybrid_cmp_context() :m_compare_type(REAL_RESULT) { }
+  Hybrid_cmp_context(const Field *field):
+    m_compare_type(field->cmp_type()),
+    cmp_collation(field->charset(), field->derivation(), field->repertoire())
+  { }
+  Item_result compare_type() const { return m_compare_type; }
+  CHARSET_INFO *compare_collation() const { return cmp_collation.collation; }
+  void set_compare_type(Item_result type) { m_compare_type= type; }
+  bool set_compare_context(const char *name, Item **args, uint arg_count);
+};
+
+
 extern Item_result item_cmp_type(Item_result a,Item_result b);
 class Item_bool_func2;
 class Arg_comparator;
@@ -36,7 +55,8 @@ typedef int (Arg_comparator::*arg_cmp_fu
 
 typedef int (*Item_field_cmpfunc)(Item *f1, Item *f2, void *arg); 
 
-class Arg_comparator: public Sql_alloc
+class Arg_comparator: public Sql_alloc,
+                      public Hybrid_cmp_context
 {
   Item **a, **b;
   arg_cmp_func func;
@@ -49,7 +69,6 @@ class Arg_comparator: public Sql_alloc
   Item *a_cache, *b_cache;         // Cached values of a and b items
                                    //   when one of arguments is NULL.
 public:
-  DTCollation cmp_collation;
   /* Allow owner function to use string buffers. */
   String value1, value2;
 
@@ -122,7 +141,9 @@ class Item_bool_func :public Item_int_fu
   Item_bool_func() :Item_int_func() {}
   Item_bool_func(Item *a) :Item_int_func(a) {}
   Item_bool_func(Item *a,Item *b) :Item_int_func(a,b) {}
+  Item_bool_func(Item *a, Item *b, Item *c) :Item_int_func(a, b, c) {}
   Item_bool_func(THD *thd, Item_bool_func *item) :Item_int_func(thd, item) {}
+  Item_bool_func(List<Item> &list) :Item_int_func(list) { }
   bool is_bool_func() { return 1; }
   void fix_length_and_dec() { decimals=0; max_length=1; }
   uint decimal_precision() const { return 1; }
@@ -364,7 +385,7 @@ class Le_creator :public Comp_creator
   virtual bool l_op() const { return 1; }
 };
 
-class Item_bool_func2 :public Item_int_func
+class Item_bool_func2 :public Item_bool_func
 {						/* Bool with 2 string args */
 protected:
   Arg_comparator cmp;
@@ -372,7 +393,7 @@ class Item_bool_func2 :public Item_int_f
 
 public:
   Item_bool_func2(Item *a,Item *b)
-    :Item_int_func(a,b), cmp(tmp_arg, tmp_arg+1),
+    :Item_bool_func(a, b), cmp(tmp_arg, tmp_arg+1),
      abort_on_null(FALSE) { sargable= TRUE; }
   void fix_length_and_dec();
   int set_cmp_func()
@@ -389,14 +410,13 @@ class Item_bool_func2 :public Item_int_f
   }
 
   bool is_null() { return MY_TEST(args[0]->is_null() || args[1]->is_null()); }
-  bool is_bool_func() { return 1; }
-  CHARSET_INFO *compare_collation() { return cmp.cmp_collation.collation; }
-  uint decimal_precision() const { return 1; }
+  CHARSET_INFO *compare_collation() const { return cmp.compare_collation(); }
+  Item_result compare_type() const { return cmp.compare_type(); }
   void top_level_item() { abort_on_null= TRUE; }
   Arg_comparator *get_comparator() { return &cmp; }
   void cleanup()
   {
-    Item_int_func::cleanup();
+    Item_bool_func::cleanup();
     cmp.cleanup();
   }
 
@@ -637,6 +657,23 @@ class Item_func_ne :public Item_bool_row
 };
 
 
+class Item_bool_func_hybrid_cmp_type :public Item_bool_func,
+                                      public Hybrid_cmp_context
+{
+public:
+  Item_bool_func_hybrid_cmp_type(const Hybrid_cmp_context context)
+    :Item_bool_func(), Hybrid_cmp_context(context) { }
+  Item_bool_func_hybrid_cmp_type(Item *a, Item *b, Item *c)
+    :Item_bool_func(a, b, c) { }
+  Item_bool_func_hybrid_cmp_type(List<Item> &list)
+    :Item_bool_func(list) { }
+  Item_result compare_type() const
+  { return Hybrid_cmp_context::compare_type(); }
+  CHARSET_INFO *compare_collation() const
+  { return  Hybrid_cmp_context::compare_collation(); }
+};
+
+
 /*
   The class Item_func_opt_neg is defined to factor out the functionality
   common for the classes Item_func_between and Item_func_in. The objects
@@ -646,16 +683,16 @@ class Item_func_ne :public Item_bool_row
 
 */
 
-class Item_func_opt_neg :public Item_int_func
+class Item_func_opt_neg :public Item_bool_func_hybrid_cmp_type
 {
 public:
   bool negated;     /* <=> the item represents NOT <func> */
   bool pred_level;  /* <=> [NOT] <func> is used on a predicate level */
 public:
   Item_func_opt_neg(Item *a, Item *b, Item *c)
-    :Item_int_func(a, b, c), negated(0), pred_level(0) {}
+    :Item_bool_func_hybrid_cmp_type(a, b, c), negated(0), pred_level(0) {}
   Item_func_opt_neg(List<Item> &list)
-    :Item_int_func(list), negated(0), pred_level(0) {}
+    :Item_bool_func_hybrid_cmp_type(list), negated(0), pred_level(0) {}
 public:
   inline void negate() { negated= !negated; }
   inline void top_level_item() { pred_level= 1; }
@@ -671,9 +708,7 @@ class Item_func_opt_neg :public Item_int
 
 class Item_func_between :public Item_func_opt_neg
 {
-  DTCollation cmp_collation;
 public:
-  Item_result cmp_type;
   String value0,value1,value2;
   /* TRUE <=> arguments will be compared as dates. */
   Item *compare_as_dates;
@@ -686,9 +721,6 @@ class Item_func_between :public Item_fun
   bool fix_fields(THD *, Item **);
   void fix_length_and_dec();
   virtual void print(String *str, enum_query_type query_type);
-  bool is_bool_func() { return 1; }
-  CHARSET_INFO *compare_collation() { return cmp_collation.collation; }
-  uint decimal_precision() const { return 1; }
   bool eval_not_null_tables(uchar *opt_arg);
   void fix_after_pullout(st_select_lex *new_parent, Item **ref);
   bool count_sargable_conds(uchar *arg);
@@ -1226,14 +1258,14 @@ class cmp_item_sort_string_in_static :pu
   function and only comparators for there result types are used.
 */
 
-class Item_func_case :public Item_func_hybrid_field_type
+class Item_func_case :public Item_func_hybrid_field_type,
+                      public Hybrid_cmp_context
 {
   int first_expr_num, else_expr_num;
   enum Item_result left_result_type;
   String tmp_value;
   uint ncases;
   Item_result cmp_type;
-  DTCollation cmp_collation;
   cmp_item *cmp_items[6]; /* For all result types */
   cmp_item *case_item;
 public:
@@ -1267,7 +1299,6 @@ class Item_func_case :public Item_func_h
   const char *func_name() const { return "case"; }
   virtual void print(String *str, enum_query_type query_type);
   Item *find_item(String *str);
-  CHARSET_INFO *compare_collation() { return cmp_collation.collation; }
   void cleanup();
   void agg_str_lengths(Item *arg);
   void agg_num_lengths(Item *arg);
@@ -1303,7 +1334,6 @@ class Item_func_in :public Item_func_opt
   bool arg_types_compatible;
   Item_result left_result_type;
   cmp_item *cmp_items[6]; /* One cmp_item for each result type */
-  DTCollation cmp_collation;
 
   Item_func_in(List<Item> &list)
     :Item_func_opt_neg(list), array(0), have_null(0),
@@ -1316,7 +1346,6 @@ class Item_func_in :public Item_func_opt
   longlong val_int();
   bool fix_fields(THD *, Item **);
   void fix_length_and_dec();
-  uint decimal_precision() const { return 1; }
   void cleanup()
   {
     uint i;
@@ -1337,8 +1366,6 @@ class Item_func_in :public Item_func_opt
   enum Functype functype() const { return IN_FUNC; }
   const char *func_name() const { return " IN "; }
   bool nulls_in_row();
-  bool is_bool_func() { return 1; }
-  CHARSET_INFO *compare_collation() { return cmp_collation.collation; }
   bool eval_not_null_tables(uchar *opt_arg);
   void fix_after_pullout(st_select_lex *new_parent, Item **ref);
 };
@@ -1374,10 +1401,22 @@ class in_row :public in_vector
 
 /* Functions used by where clause */
 
-class Item_func_isnull :public Item_bool_func
+
+class Item_func_null_predicate :public Item_bool_func
 {
 public:
-  Item_func_isnull(Item *a) :Item_bool_func(a) { sargable= TRUE; }
+  Item_func_null_predicate(Item *a) :Item_bool_func(a) { sargable= true; }
+  optimize_type select_optimize() const { return OPTIMIZE_NULL; }
+  CHARSET_INFO *compare_collation() const
+  { return args[0]->collation.collation; }
+  Item_result compare_type() const { return args[0]->cmp_type(); }
+};
+
+
+class Item_func_isnull :public Item_func_null_predicate
+{
+public:
+  Item_func_isnull(Item *a) :Item_func_null_predicate(a) { }
   longlong val_int();
   enum Functype functype() const { return ISNULL_FUNC; }
   void fix_length_and_dec()
@@ -1402,9 +1441,7 @@ class Item_func_isnull :public Item_bool
     }
   }
   table_map not_null_tables() const { return 0; }
-  optimize_type select_optimize() const { return OPTIMIZE_NULL; }
   Item *neg_transformer(THD *thd);
-  CHARSET_INFO *compare_collation() { return args[0]->collation.collation; }
 };
 
 /* Functions used by HAVING for rewriting IN subquery */
@@ -1435,12 +1472,12 @@ class Item_is_not_null_test :public Item
 };
 
 
-class Item_func_isnotnull :public Item_bool_func
+class Item_func_isnotnull :public Item_func_null_predicate
 {
   bool abort_on_null;
 public:
-  Item_func_isnotnull(Item *a) :Item_bool_func(a), abort_on_null(0)
-  { sargable= TRUE; }
+  Item_func_isnotnull(Item *a) :Item_func_null_predicate(a), abort_on_null(0)
+  { }
   longlong val_int();
   enum Functype functype() const { return ISNOTNULL_FUNC; }
   void fix_length_and_dec()
@@ -1448,12 +1485,10 @@ class Item_func_isnotnull :public Item_b
     decimals=0; max_length=1; maybe_null=0;
   }
   const char *func_name() const { return "isnotnull"; }
-  optimize_type select_optimize() const { return OPTIMIZE_NULL; }
   table_map not_null_tables() const
   { return abort_on_null ? not_null_tables_cache : 0; }
   Item *neg_transformer(THD *thd);
   virtual void print(String *str, enum_query_type query_type);
-  CHARSET_INFO *compare_collation() { return args[0]->collation.collation; }
   void top_level_item() { abort_on_null=1; }
 };
 
@@ -1603,7 +1638,6 @@ class Item_func_regex :public Item_bool_
     print_op(str, query_type);
   }
 
-  CHARSET_INFO *compare_collation() { return cmp_collation.collation; }
 };
 
 
@@ -1771,7 +1805,7 @@ template <template<class> class LI, clas
   object represents f1=f2= ...=fn to the projection of known fields fi1=...=fik.
 */
 
-class Item_equal: public Item_bool_func
+class Item_equal: public Item_bool_func_hybrid_cmp_type
 {
   /*
     The list of equal items. Currently the list can contain:
@@ -1835,11 +1869,8 @@ class Item_equal: public Item_bool_func
 
   COND_EQUAL *upper_levels;       /* multiple equalities of upper and levels */
 
-  inline Item_equal()
-    : Item_bool_func(), with_const(FALSE), eval_item(0), cond_false(0),
-      context_field(NULL)
-  { const_item_cache=0; sargable= TRUE; }
-  Item_equal(Item *f1, Item *f2, bool with_const_item);
+  Item_equal(const Hybrid_cmp_context context,
+             Item *f1, Item *f2, bool with_const_item);
   Item_equal(Item_equal *item_equal);
   /* Currently the const item is always the first in the list of equal items */
   inline Item* get_const() { return with_const ? equal_items.head() : NULL; }
@@ -1866,8 +1897,6 @@ class Item_equal: public Item_bool_func
   bool walk(Item_processor processor, bool walk_subquery, uchar *arg);
   Item *transform(Item_transformer transformer, uchar *arg);
   virtual void print(String *str, enum_query_type query_type);
-  CHARSET_INFO *compare_collation();
-
   void set_context_field(Item_field *ctx_field) { context_field= ctx_field; }
   void set_link_equal_fields(bool flag) { link_equal_fields= flag; }
   friend class Item_equal_fields_iterator;

=== modified file 'sql/item_func.h'
--- sql/item_func.h	2014-08-07 16:06:56 +0000
+++ sql/item_func.h	2014-11-03 07:43:02 +0000
@@ -30,7 +30,32 @@ extern "C"				/* Bug in BSDI include fil
 }
 #endif
 
-class Item_func :public Item_result_field
+
+/*
+  Item_func metods that are needed for Field_optimizer->can_optimize_xxx().
+  In fact, these methods are only called for some Item_bool_func descendants.
+  Have DBUG_ASSERT as the default method implementation.
+  All Item_bool_func descendants that really use
+  Field_optimizer->can_optimize_xxx() override these methods.
+*/
+class Cmp_context_owner
+{
+public:
+  virtual CHARSET_INFO *compare_collation() const
+  {
+    DBUG_ASSERT(0);
+    return NULL;
+  }
+  virtual Item_result compare_type() const
+  {
+    DBUG_ASSERT(0);
+    return REAL_RESULT;
+  }
+};
+
+
+class Item_func :public Item_result_field,
+                 public Cmp_context_owner
 {
 protected:
   Item **args, *tmp_arg[2];

=== modified file 'sql/opt_range.cc'
--- sql/opt_range.cc	2014-10-28 21:33:31 +0000
+++ sql/opt_range.cc	2014-11-03 06:40:38 +0000
@@ -853,11 +853,14 @@ class RANGE_OPT_PARAM
   uint keys;
   
   /* 
-    If true, the index descriptions describe real indexes (and it is ok to
-    call field->optimize_range(real_keynr[...], ...).
+    If true, the index descriptions describe real indexes.
     Otherwise index description describes fake indexes.
   */
-  bool using_real_indexes;
+  virtual bool using_real_indexes() const = 0;
+
+  virtual bool can_optimize(Item_func *conf_func, Field *field,
+                            KEY_PART *key_part,
+                            Item_func::Functype type, Item *value) const = 0;
   
   /*
     Aggressively remove "scans" that do not have conditions on first
@@ -892,8 +895,25 @@ class RANGE_OPT_PARAM
       thd->is_error() ||
       alloced_sel_args > SEL_ARG::MAX_SEL_ARGS;
   }
+
+};
+
+
+class RANGE_OPT_PARAM_PARTITION: public RANGE_OPT_PARAM
+{
+public:
+  bool using_real_indexes() const { return false; }
+  bool can_optimize(Item_func *cond, Field *field, KEY_PART *key_part,
+                    Item_func::Functype func_type, Item *value) const
+  {
+    return
+      func_type == Item_func::EQ_FUNC || func_type == Item_func::EQUAL_FUNC ?
+      field->can_optimize_partition_ref(cond, value) :
+      field->can_optimize_partition_range(cond, value);
+  }
 };
 
+
 class PARAM : public RANGE_OPT_PARAM
 {
 public:
@@ -925,6 +945,30 @@ class PARAM : public RANGE_OPT_PARAM
   /* Number of ranges in the last checked tree->key */
   uint n_ranges;
   uint8 first_null_comp; /* first null component if any, 0 - otherwise */
+  bool using_real_indexes() const { return true; }
+  bool can_optimize(Item_func *cond, Field *field, KEY_PART *key_part,
+                    Item_func::Functype type, Item *value) const
+  {
+    uint keyno= real_keynr[key_part->key];
+    KEY *key= &table->key_info[keyno];
+    return (type == Item_func::EQ_FUNC || type == Item_func::EQUAL_FUNC) ?
+      field->can_optimize_keypart_range_trivial(key, keyno, key_part->part,
+                                                cond, value) :
+      field->can_optimize_keypart_range(key, keyno, key_part->part,
+                                        cond, value);
+  }
+};
+
+
+class PARAM_FOR_SELECTIVITY: public PARAM
+{
+public:
+  bool using_real_indexes() const { return false; }
+  bool can_optimize(Item_func *cond, Field *field, KEY_PART *key_part,
+                    Item_func::Functype type, Item *value) const
+  {
+    return field->can_optimize_for_selectivity(cond, value);
+  }
 };
 
 
@@ -939,10 +983,12 @@ class TABLE_READ_PLAN;
 struct st_index_scan_info;
 struct st_ror_scan_info;
 
-static SEL_TREE * get_mm_parts(RANGE_OPT_PARAM *param,COND *cond_func,Field *field,
+static SEL_TREE * get_mm_parts(RANGE_OPT_PARAM *param,
+                               Item_func *cond_func, Field *field,
 			       Item_func::Functype type,Item *value,
 			       Item_result cmp_type);
-static SEL_ARG *get_mm_leaf(RANGE_OPT_PARAM *param,COND *cond_func,Field *field,
+static SEL_ARG *get_mm_leaf(RANGE_OPT_PARAM *param,
+                            Item_func *cond_func, Field *field,
 			    KEY_PART *key_part,
 			    Item_func::Functype type,Item *value);
 static SEL_TREE *get_mm_tree(RANGE_OPT_PARAM *param,COND *cond);
@@ -3047,7 +3093,6 @@ int SQL_SELECT::test_quick_select(THD *t
     param.old_root= thd->mem_root;
     param.needed_reg= &needed_reg;
     param.imerge_cost_buff_size= 0;
-    param.using_real_indexes= TRUE;
     param.remove_jump_scans= TRUE;
     param.force_default_mrr= ordered_output;
     param.possible_keys.clear_all();
@@ -3592,7 +3637,7 @@ bool calculate_cond_selectivity_for_tabl
   if (thd->variables.optimizer_use_condition_selectivity > 2 &&
       !bitmap_is_clear_all(used_fields))
   {
-    PARAM param;
+    PARAM_FOR_SELECTIVITY param;
     MEM_ROOT alloc;
     SEL_TREE *tree;
     SEL_ARG **key, **end;
@@ -3612,7 +3657,6 @@ bool calculate_cond_selectivity_for_tabl
 
     param.prev_tables= param.read_tables= 0;
     param.current_table= table->map;
-    param.using_real_indexes= FALSE;
     param.real_keynr[0]= 0;
     param.alloced_sel_args= 0;
 
@@ -3890,10 +3934,9 @@ typedef void (*mark_full_part_func)(part
 /*
   Partition pruning operation context
 */
-typedef struct st_part_prune_param
+class PART_PRUNE_PARAM: public RANGE_OPT_PARAM_PARTITION
 {
-  RANGE_OPT_PARAM range_param; /* Range analyzer parameters */
-
+public:
   /***************************************************************
    Following fields are filled in based solely on partitioning 
    definition and not modified after that:
@@ -3953,7 +3996,7 @@ typedef struct st_part_prune_param
   uchar *cur_max_key;
 
   uint cur_min_flag, cur_max_flag;
-} PART_PRUNE_PARAM;
+};
 
 static bool create_partition_index_description(PART_PRUNE_PARAM *prune_par);
 static int find_used_partitions(PART_PRUNE_PARAM *ppar, SEL_ARG *key_tree);
@@ -4010,7 +4053,7 @@ bool prune_partitions(THD *thd, TABLE *t
   
   PART_PRUNE_PARAM prune_param;
   MEM_ROOT alloc;
-  RANGE_OPT_PARAM  *range_par= &prune_param.range_param;
+  RANGE_OPT_PARAM  *range_par= &prune_param;
   my_bitmap_map *old_sets[2];
 
   prune_param.part_info= part_info;
@@ -4035,7 +4078,6 @@ bool prune_partitions(THD *thd, TABLE *t
   range_par->current_table= table->map;
 
   range_par->keys= 1; // one index
-  range_par->using_real_indexes= FALSE;
   range_par->remove_jump_scans= FALSE;
   range_par->real_keynr[0]= 0;
   range_par->alloced_sel_args= 0;
@@ -4045,7 +4087,7 @@ bool prune_partitions(THD *thd, TABLE *t
 
   bitmap_clear_all(&part_info->read_partitions);
 
-  prune_param.key= prune_param.range_param.key_parts;
+  prune_param.key= prune_param.key_parts;
   SEL_TREE *tree;
   int res;
 
@@ -4069,8 +4111,8 @@ bool prune_partitions(THD *thd, TABLE *t
     prune_param.cur_part_fields= 0;
     prune_param.cur_subpart_fields= 0;
     
-    prune_param.cur_min_key= prune_param.range_param.min_key;
-    prune_param.cur_max_key= prune_param.range_param.max_key;
+    prune_param.cur_min_key= prune_param.min_key;
+    prune_param.cur_max_key= prune_param.max_key;
     prune_param.cur_min_flag= prune_param.cur_max_flag= 0;
 
     init_all_partitions_iterator(part_info, &prune_param.part_iter);
@@ -4174,7 +4216,7 @@ bool prune_partitions(THD *thd, TABLE *t
 static void store_selargs_to_rec(PART_PRUNE_PARAM *ppar, SEL_ARG **start,
                                  int num)
 {
-  KEY_PART *parts= ppar->range_param.key_parts;
+  KEY_PART *parts= ppar->key_parts;
   for (SEL_ARG **end= start + num; start != end; start++)
   {
     SEL_ARG *sel_arg= (*start);
@@ -4236,7 +4278,7 @@ static int find_used_partitions_imerge_l
   my_bitmap_map *bitmap_buf;
   uint n_bits= ppar->part_info->read_partitions.n_bits;
   bitmap_bytes= bitmap_buffer_size(n_bits);
-  if (!(bitmap_buf= (my_bitmap_map*) alloc_root(ppar->range_param.mem_root,
+  if (!(bitmap_buf= (my_bitmap_map*) alloc_root(ppar->mem_root,
                                                 bitmap_bytes)))
   {
     /*
@@ -4300,8 +4342,8 @@ int find_used_partitions_imerge(PART_PRU
     ppar->cur_part_fields= 0;
     ppar->cur_subpart_fields= 0;
     
-    ppar->cur_min_key= ppar->range_param.min_key;
-    ppar->cur_max_key= ppar->range_param.max_key;
+    ppar->cur_min_key= ppar->min_key;
+    ppar->cur_max_key= ppar->max_key;
     ppar->cur_min_flag= ppar->cur_max_flag= 0;
 
     init_all_partitions_iterator(ppar->part_info, &ppar->part_iter);
@@ -4431,7 +4473,7 @@ int find_used_partitions(PART_PRUNE_PARA
   bool set_full_part_if_bad_ret= FALSE;
   bool ignore_part_fields= ppar->ignore_part_fields;
   bool did_set_ignore_part_fields= FALSE;
-  RANGE_OPT_PARAM *range_par= &(ppar->range_param);
+  RANGE_OPT_PARAM *range_par= ppar;
 
   if (check_stack_overrun(range_par->thd, 3*STACK_MIN_SIZE, NULL))
     return -1;
@@ -4842,7 +4884,7 @@ static bool fields_ok_for_partition_inde
 
 static bool create_partition_index_description(PART_PRUNE_PARAM *ppar)
 {
-  RANGE_OPT_PARAM *range_par= &(ppar->range_param);
+  RANGE_OPT_PARAM *range_par= ppar;
   partition_info *part_info= ppar->part_info;
   uint used_part_fields, used_subpart_fields;
 
@@ -7530,7 +7572,8 @@ QUICK_SELECT_I *TRP_ROR_UNION::make_quic
     0  on error
 */
 
-static SEL_TREE *get_ne_mm_tree(RANGE_OPT_PARAM *param, Item_func *cond_func, 
+static SEL_TREE *get_ne_mm_tree(RANGE_OPT_PARAM *param,
+                                Item_func *cond_func, 
                                 Field *field,
                                 Item *lt_value, Item *gt_value,
                                 Item_result cmp_type)
@@ -7565,7 +7608,8 @@ static SEL_TREE *get_ne_mm_tree(RANGE_OP
     Pointer to the tree built tree
 */
 
-static SEL_TREE *get_func_mm_tree(RANGE_OPT_PARAM *param, Item_func *cond_func, 
+static SEL_TREE *get_func_mm_tree(RANGE_OPT_PARAM *param,
+                                  Item_func *cond_func, 
                                   Field *field, Item *value,
                                   Item_result cmp_type, bool inv)
 {
@@ -7732,7 +7776,7 @@ static SEL_TREE *get_func_mm_tree(RANGE_
 
                   Partitioning indexes are never partial.
                 */
-                if (param->using_real_indexes)
+                if (param->using_real_indexes())
                 {
                   const KEY key=
                     param->table->key_info[param->real_keynr[idx]];
@@ -8086,7 +8130,7 @@ static SEL_TREE *get_mm_tree(RANGE_OPT_P
       Item_result cmp_type= field->cmp_type();
       if (!((ref_tables | field->table->map) & param_comp))
       {
-        tree= get_mm_parts(param, cond, field, Item_func::EQ_FUNC,
+        tree= get_mm_parts(param, item_equal, field, Item_func::EQ_FUNC,
 		           value,cmp_type);
         ftree= !ftree ? tree : tree_and(param, ftree, tree);
       }
@@ -8139,7 +8183,7 @@ static SEL_TREE *get_mm_tree(RANGE_OPT_P
 
 
 static SEL_TREE *
-get_mm_parts(RANGE_OPT_PARAM *param, COND *cond_func, Field *field,
+get_mm_parts(RANGE_OPT_PARAM *param, Item_func *cond_func, Field *field,
 	     Item_func::Functype type,
 	     Item *value, Item_result cmp_type)
 {
@@ -8192,11 +8236,10 @@ get_mm_parts(RANGE_OPT_PARAM *param, CON
 
 
 static SEL_ARG *
-get_mm_leaf(RANGE_OPT_PARAM *param, COND *conf_func, Field *field,
+get_mm_leaf(RANGE_OPT_PARAM *param, Item_func *conf_func, Field *field,
             KEY_PART *key_part, Item_func::Functype type,Item *value)
 {
   uint maybe_null=(uint) field->real_maybe_null();
-  bool optimize_range;
   SEL_ARG *tree= 0;
   MEM_ROOT *alloc= param->mem_root;
   uchar *str;
@@ -8232,55 +8275,9 @@ get_mm_leaf(RANGE_OPT_PARAM *param, COND
     goto end;
   }
 
-  /*
-    1. Usually we can't use an index if the column collation
-       differ from the operation collation.
-
-    2. However, we can reuse a case insensitive index for
-       the binary searches:
-
-       WHERE latin1_swedish_ci_column = 'a' COLLATE lati1_bin;
-
-       WHERE latin1_swedish_ci_colimn = BINARY 'a '
-
-  */
-  if (field->result_type() == STRING_RESULT &&
-      field->match_collation_to_optimize_range() &&
-      value->result_type() == STRING_RESULT &&
-      key_part->image_type == Field::itRAW &&
-      field->charset() != conf_func->compare_collation() &&
-      !(conf_func->compare_collation()->state & MY_CS_BINSORT &&
-        (type == Item_func::EQUAL_FUNC || type == Item_func::EQ_FUNC)))
+  if (!param->can_optimize(conf_func, field, key_part, type, value))
     goto end;
 
-  if (key_part->image_type == Field::itMBR)
-  {
-    // @todo: use is_spatial_operator() instead?
-    switch (type) {
-    case Item_func::SP_EQUALS_FUNC:
-    case Item_func::SP_DISJOINT_FUNC:
-    case Item_func::SP_INTERSECTS_FUNC:
-    case Item_func::SP_TOUCHES_FUNC:
-    case Item_func::SP_CROSSES_FUNC:
-    case Item_func::SP_WITHIN_FUNC:
-    case Item_func::SP_CONTAINS_FUNC:
-    case Item_func::SP_OVERLAPS_FUNC:
-      break;
-    default:
-      /* 
-        We cannot involve spatial indexes for queries that
-        don't use MBREQUALS(), MBRDISJOINT(), etc. functions.
-      */
-      goto end;
-    }
-  }
-
-  if (param->using_real_indexes)
-    optimize_range= field->optimize_range(param->real_keynr[key_part->key],
-                                          key_part->part);
-  else
-    optimize_range= TRUE;
-
   if (type == Item_func::LIKE_FUNC)
   {
     bool like_error;
@@ -8290,8 +8287,6 @@ get_mm_leaf(RANGE_OPT_PARAM *param, COND
     size_t length, offset, min_length, max_length;
     uint field_length= field->pack_length()+maybe_null;
 
-    if (!optimize_range)
-      goto end;
     if (!(res= value->val_str(&tmp)))
     {
       tree= &null_element;
@@ -8361,17 +8356,6 @@ get_mm_leaf(RANGE_OPT_PARAM *param, COND
     goto end;
   }
 
-  if (!optimize_range &&
-      type != Item_func::EQ_FUNC &&
-      type != Item_func::EQUAL_FUNC)
-    goto end;                                   // Can't optimize this
-
-  /*
-    We can't always use indexes when comparing a string index to a number
-    cmp_type() is checked to allow compare of dates to numbers
-  */
-  if (field->cmp_type() == STRING_RESULT && value->cmp_type() != STRING_RESULT)
-    goto end;
   err= value->save_in_field_no_warnings(field, 1);
   if (err == 2 && field->cmp_type() == STRING_RESULT)
   {
@@ -12500,7 +12484,7 @@ static bool get_constant_key_infix(KEY *
                        KEY_PART_INFO **first_non_infix_part);
 static bool
 check_group_min_max_predicates(Item *cond, Item_field *min_max_arg_item,
-                               Field::imagetype image_type,
+                               const KEY *key,
                                bool *has_min_max_fld, bool *has_other_fld);
 
 static void
@@ -13105,8 +13089,7 @@ get_best_group_min_max(PARAM *param, SEL
   bool has_min_max_fld= false, has_other_fld= false;
   if (join->conds && min_max_arg_item &&
       !check_group_min_max_predicates(join->conds, min_max_arg_item,
-                                      (index_info->flags & HA_SPATIAL) ?
-                                      Field::itMBR : Field::itRAW,
+                                      index_info,
                                       &has_min_max_fld, &has_other_fld))
     DBUG_RETURN(NULL);
 
@@ -13157,7 +13140,7 @@ get_best_group_min_max(PARAM *param, SEL
     check_group_min_max_predicates()
     cond        [in]  the expression tree being analyzed
     min_max_arg [in]  the field referenced by the MIN/MAX function(s)
-    image_type  [in]
+    key         [in]
     has_min_max_arg [out] true if the subtree being analyzed references min_max_arg
     has_other_arg   [out] true if the subtree being analyzed references a column
                           other min_max_arg
@@ -13181,7 +13164,7 @@ get_best_group_min_max(PARAM *param, SEL
 
 static bool
 check_group_min_max_predicates(Item *cond, Item_field *min_max_arg_item,
-                               Field::imagetype image_type,
+                               const KEY *key,
                                bool *has_min_max_arg, bool *has_other_arg)
 {
   DBUG_ENTER("check_group_min_max_predicates");
@@ -13205,7 +13188,7 @@ check_group_min_max_predicates(Item *con
             the min/max argument and other columns.
       */
       if (!check_group_min_max_predicates(and_or_arg, min_max_arg_item,      //1
-                                          image_type,
+                                          key,
                                           &has_min_max, &has_other) ||
           (func_type == Item_func::COND_OR_FUNC && has_min_max && has_other))//2
         DBUG_RETURN(FALSE);
@@ -13317,23 +13300,10 @@ check_group_min_max_predicates(Item *con
         if (!simple_pred(pred, args, &inv))
           DBUG_RETURN(FALSE);
 
-        /* Check for compatible string comparisons - similar to get_mm_leaf. */
         if (args[0] && args[1] && !args[2] && // this is a binary function
-            min_max_arg_item->result_type() == STRING_RESULT &&
-            /*
-              Don't use an index when comparing strings of different collations.
-            */
-            ((args[1]->result_type() == STRING_RESULT &&
-              image_type == Field::itRAW &&
-              min_max_arg_item->field->charset() !=
-              pred->compare_collation())
-             ||
-             /*
-               We can't always use indexes when comparing a string index to a
-               number.
-             */
-             (args[1]->result_type() != STRING_RESULT &&
-              min_max_arg_item->field->cmp_type() != args[1]->result_type())))
+            !min_max_arg_item->field->can_optimize_key_group_min_max(key,
+                                                                     pred,
+                                                                     args[1]))
           DBUG_RETURN(FALSE);
       }
       else
@@ -13341,7 +13311,7 @@ check_group_min_max_predicates(Item *con
     }
     else if (cur_arg->type() == Item::FUNC_ITEM)
     {
-      if (!check_group_min_max_predicates(cur_arg, min_max_arg_item, image_type,
+      if (!check_group_min_max_predicates(cur_arg, min_max_arg_item, key,
                                           &has_min_max, &has_other))
         DBUG_RETURN(FALSE);
     }

=== modified file 'sql/opt_table_elimination.cc'
--- sql/opt_table_elimination.cc	2014-02-19 10:05:15 +0000
+++ sql/opt_table_elimination.cc	2014-11-03 04:05:14 +0000
@@ -1486,24 +1486,9 @@ void check_equality(Dep_analysis_context
       left->real_item()->type() == Item::FIELD_ITEM)
   {
     Field *field= ((Item_field*)left->real_item())->field;
-    if (field->result_type() == STRING_RESULT)
-    {
-      if (right->result_type() != STRING_RESULT)
-      {
-        if (field->cmp_type() != right->result_type())
-          return;
-      }
-      else
-      {
-        /*
-          We can't assume there's a functional dependency if the effective
-          collation of the operation differ from the field collation.
-        */
-        if (field->cmp_type() == STRING_RESULT &&
-            field->charset() != cond->compare_collation())
-          return;
-      }
-    }
+    if (!field->can_optimize_equality_for_outer_join_table_elimination(cond,
+                                                                       right))
+      return;
     Dep_value_field *field_val;
     if ((field_val= ctx->get_field_value(field)))
       add_module_expr(ctx, eq_mod, and_level, field_val, right, NULL);

